#!/bin/bash

PATH=$PATH:/usr/bin:/bin:/sbin:/user/sbin

version="1.2015060201"

outdir=""
outfile=""

while getopts f:d: flag
do
  case $flag in
    f)
     outfile=$OPTARG;;
    d)
     outdir=$OPTARG;;
  esac
done 2>/dev/null

if [ "0$outdir" == "0" ]
then
  SCRIPT_PATH="${BASH_SOURCE[0]}";
  if ([ -h "${SCRIPT_PATH}" ]) then
    while([ -h "${SCRIPT_PATH}" ]) do SCRIPT_PATH=`readlink "${SCRIPT_PATH}"`; done
  fi
  pushd . > /dev/null
  cd `dirname "${SCRIPT_PATH}"` > /dev/null
  SCRIPT_PATH=`pwd`;
  popd  > /dev/null

  outdir=$SCRIPT_PATH
fi

if [ "0$outfile" == "0" ]
then
  outfile="`hostname | cut -d'.' -f1`-`ifconfig -a | grep ether | head -1 | awk '{print $2}' | tr -d ':'`.cdf"
fi

if [ ! -d $outdir ]
then
  echo "Error: directory does not exist ($outdir)."
  exit
fi

echo "$outfile" | grep 'cdf$' >/dev/null 2>&1
if [ $? -ne 0 ]
then
  outfile="${outfile}.cdf"
fi

rm -f /tmp/$outfile /tmp/$outfile.tmp 2>/dev/null
	
echo "Mac Data Collector:" > /tmp/$outfile.tmp 2>/dev/null
	
echo "" >> /tmp/$outfile.tmp 2>/dev/null
	
echo "    Collection Information:" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null
echo "      Version: " $version >> /tmp/$outfile.tmp 2>/dev/null
echo "      Run Date: " `date "+%m/%d/%Y %r"` >> /tmp/$outfile.tmp 2>/dev/null
echo "      User: " $USER >> /tmp/$outfile.tmp 2>/dev/null
echo "      Computer Name: " `scutil --get ComputerName 2>/dev/null` >> /tmp/$outfile.tmp 2>/dev/null
echo "      Host Name: " `Hostname` >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null

echo "    FileVault Status:" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null
op=`fdesetup status 2>/dev/null`;
echo "$op" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null

echo "    DF Output:" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null
echo "`df -k`" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null
	
echo "    Ifconfig Output:" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null
echo "`ifconfig -a`" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null
	
echo "    Netstat Output:" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null
echo "`netstat -an | egrep "LIST|udp"`" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null

echo "    lsof Output:" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null
echo "`lsof -i -n -P | grep TCP | grep LISTEN | grep v4`" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null

echo "    Last:" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null
echo "`last`" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null
	
echo "    Resolv.conf:" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null
echo "`cat /etc/resolv.conf |grep -v ^#`" >> /tmp/$outfile.tmp 2>/dev/null
echo "" >> /tmp/$outfile.tmp 2>/dev/null

system_profiler SPHardwareDataType SPNetworkDataType SPSoftwareDataType SPDiagnosticsDataType SPMemoryDataType SPPrintersDataType SPFirewallDataType SPSerialATADataType SPApplicationsDataType >> /tmp/$outfile.tmp 2>/dev/null

chk=`which openssl`
if [ "0$chk" == "0" ]
then
  cp /tmp/$outfile.tmp $outdir/$outfile
else
  openssl base64 -in /tmp/$outfile.tmp -out /tmp/$outfile
  if [ "0$outdir" != "0/tmp" ]
  then
    cp /tmp/$outfile $outdir/$outfile
  fi
fi

rm -f /tmp/$outfile.tmp 2>/dev/null

if [ "0$outdir" != "0/tmp" ]
then
  rm -f /tmp/$outfile 2>/dev/null
fi

